searchNodes=[{"doc":"Parse RSS quickly using a Rust nif.","ref":"FastRSS.html","title":"FastRSS","type":"module"},{"doc":"Parse a RSS string into a map","ref":"FastRSS.html#parse/1","title":"FastRSS.parse/1","type":"function"},{"doc":"Parse RSS feeds very quickly Intro | Compatibility | Installation | Usage | Benchmarks | Deploying | License","ref":"readme.html","title":"README","type":"extras"},{"doc":"Parse RSS feeds very quickly This is rust NIF built using rustler Uses the RSS rust crate to do the actual RSS parsing Speed Currently this is already much faster than most of the pure elixir/erlang packages out there. In benchmarks there are speed improvements anywhere between 6.12x - 50.09x over the next fastest package (feeder_ex) that was tested. Compared to the slowest elixir options tested (feed_raptor, elixir_feed_parser), FastRSS was sometimes 259.91x faster and used 5,412,308.17x less memory (0.00156 MB vs 8423.70 MB). See full benchmarks below:","ref":"readme.html#intro","title":"README - Intro","type":"extras"},{"doc":"FastRSS requires a minimum combination of Elixir 1.6.0 and Erlang/OTP 20.0, and is tested with a maximum combination of Elixir 1.10.1 and Erlang/OTP 22.0.","ref":"readme.html#compatibility","title":"README - Compatibility","type":"extras"},{"doc":"This package is available on hex. It can be installed by adding fast_rss to your list of dependencies in mix.exs: def deps do [ {:fast_rss, &quot;~&gt; 0.3.0&quot;} ] end You also need the rust compiler installed: https://www.rust-lang.org/tools/install curl --proto &#39;=https&#39; --tlsv1.2 -sSf https://sh.rustup.rs | sh","ref":"readme.html#installation","title":"README - Installation","type":"extras"},{"doc":"There is only one function it takes an RSS string and outputs an {:ok, map()} with string keys. iex(1)&gt; {:ok, map_of_rss} = FastRSS.parse(&quot;...rss_feed_string...&quot;) iex(2)&gt; Map.keys(map_of_rss) [&quot;categories&quot;, &quot;cloud&quot;, &quot;copyright&quot;, &quot;description&quot;, &quot;docs&quot;, &quot;dublin_core_ext&quot;, &quot;extensions&quot;, &quot;generator&quot;, &quot;image&quot;, &quot;items&quot;, &quot;itunes_ext&quot;, &quot;language&quot;, &quot;last_build_date&quot;, &quot;link&quot;, &quot;managing_editor&quot;, &quot;namespaces&quot;, &quot;pub_date&quot;, &quot;rating&quot;, &quot;skip_days&quot;, &quot;skip_hours&quot;, &quot;syndication_ext&quot;, &quot;text_input&quot;, &quot;title&quot;, &quot;ttl&quot;, &quot;webmaster&quot;] The docs can be found at https://hexdocs.pm/fast_rss. Supported Feeds Reading from the following RSS versions is supported: RSS 0.90 RSS 0.91 RSS 0.92 RSS 1.0 RSS 2.0 iTunes Dublin Core","ref":"readme.html#usage","title":"README - Usage","type":"extras"},{"doc":"HTML: https://avencera.github.io/fast_rss/ Benchmark run from 2020-02-22 05:23:47.524699Z UTC System Benchmark suite executing on the following system: Operating System macOS CPU Information Intel(R) Core(TM) i9-9880H CPU @ 2.30GHz Number of Available Cores 16 Available Memory 32 GB Elixir Version 1.10.1 Erlang Version 22.2.6 Configuration Benchmark suite executing with the following configuration: :time 30 s :parallel 1 :warmup 5 s Statistics Input: anxiety Run Time Name IPS Average Devitation Median 99th&nbsp;% fast_rss 188.57 5.30 ms ±8.26% 5.45 ms 6.43 ms feeder_ex 3.70 269.92 ms ±5.34% 268.12 ms 316.12 ms feed_raptor 2.99 334.01 ms ±2.44% 331.03 ms 371.28 ms elixir_feed_parser 1.94 515.72 ms ±1.94% 516.10 ms 536.05 ms Comparison Name IPS Slower fast_rss 188.57 &nbsp; feeder_ex 3.70 50.9x feed_raptor 2.99 62.99x elixir_feed_parser 1.94 97.25x Memory Usage Name Memory Factor fast_rss 0.00156 MB &nbsp; feeder_ex 17.21 MB 11004.73x feed_raptor 268.53 MB 171693.91x elixir_feed_parser 313.30 MB 200316.09x Input: ben Run Time Name IPS Average Devitation Median 99th&nbsp;% fast_rss 83.95 11.91 ms ±10.29% 12.23 ms 16.17 ms feeder_ex 13.33 75.04 ms ±4.38% 74.21 ms 89.72 ms elixir_feed_parser 3.52 284.18 ms ±3.89% 283.83 ms 324.08 ms feed_raptor 0.48 2078.76 ms ±0.52% 2076.27 ms 2097.44 ms Comparison Name IPS Slower fast_rss 83.95 &nbsp; feeder_ex 13.33 6.3x elixir_feed_parser 3.52 23.86x feed_raptor 0.48 174.51x Memory Usage Name Memory Factor fast_rss 0.00155 MB &nbsp; feeder_ex 27.86 MB 17990.96x elixir_feed_parser 163.88 MB 105811.88x feed_raptor 1577.41 MB 1018492.36x Input: daily Run Time Name IPS Average Devitation Median 99th&nbsp;% fast_rss 32.98 0.0303 s ±7.62% 0.0313 s 0.0339 s feeder_ex 4.94 0.20 s ±4.61% 0.199 s 0.24 s elixir_feed_parser 0.64 1.57 s ±1.50% 1.57 s 1.63 s feed_raptor 0.127 7.88 s ±0.23% 7.88 s 7.90 s Comparison Name IPS Slower fast_rss 32.98 &nbsp; feeder_ex 4.94 6.68x elixir_feed_parser 0.64 51.86x feed_raptor 0.127 259.91x Memory Usage Name Memory Factor fast_rss 0.00153 MB &nbsp; feeder_ex 109.73 MB 71555.78x elixir_feed_parser 880.51 MB 574178.95x feed_raptor 6386.12 MB 4164382.64x Input: dave Run Time Name IPS Average Devitation Median 99th&nbsp;% fast_rss 407.08 2.46 ms ±9.83% 2.41 ms 3.16 ms feeder_ex 56.52 17.69 ms ±6.14% 17.37 ms 22.51 ms elixir_feed_parser 8.90 112.31 ms ±4.12% 111.93 ms 127.60 ms feed_raptor 1.59 628.45 ms ±1.60% 626.71 ms 656.74 ms Comparison Name IPS Slower fast_rss 407.08 &nbsp; feeder_ex 56.52 7.2x elixir_feed_parser 8.90 45.72x feed_raptor 1.59 255.83x Memory Usage Name Memory Factor fast_rss 0.00157 MB &nbsp; feeder_ex 9.25 MB 5886.17x elixir_feed_parser 80.42 MB 51170.23x feed_raptor 571.18 MB 363425.45x Input: sleepy Run Time Name IPS Average Devitation Median 99th&nbsp;% fast_rss 760.30 1.32 ms ±16.62% 1.21 ms 2.03 ms feeder_ex 124.28 8.05 ms ±6.94% 8.03 ms 10.32 ms elixir_feed_parser 26.26 38.09 ms ±5.08% 37.81 ms 44.42 ms feed_raptor 3.21 311.16 ms ±2.85% 307.86 ms 345.09 ms Comparison Name IPS Slower fast_rss 760.30 &nbsp; feeder_ex 124.28 6.12x elixir_feed_parser 26.26 28.96x feed_raptor 3.21 236.57x Memory Usage Name Memory Factor fast_rss 0.00157 MB &nbsp; feeder_ex 4.28 MB 2726.19x elixir_feed_parser 35.88 MB 22829.92x feed_raptor 274.98 MB 174963.99x Input: stuff Run Time Name IPS Average Devitation Median 99th&nbsp;% fast_rss 19.19 0.0521 s ±9.19% 0.0546 s 0.0635 s feeder_ex 0.93 1.07 s ±2.49% 1.07 s 1.15 s elixir_feed_parser 0.53 1.88 s ±1.22% 1.89 s 1.92 s feed_raptor 0.0797 12.54 s ±1.61% 12.44 s 12.77 s Comparison Name IPS Slower fast_rss 19.19 &nbsp; feeder_ex 0.93 20.59x elixir_feed_parser 0.53 36.11x feed_raptor 0.0797 240.68x Memory Usage Name Memory Factor fast_rss 0.00154 MB &nbsp; feeder_ex 140.58 MB 91220.55x elixir_feed_parser 1018.78 MB 661058.28x feed_raptor 8424.44 MB 5466379.81x","ref":"readme.html#benchmark","title":"README - Benchmark","type":"extras"},{"doc":"Deploying rust NIFs can be a little bit annoying as you have to install the rust compiler. If you are having trouble deploying this package make an issue and I will try and help you out. I will then add it to the FAQ below. Q. How do I deploy using an Alpine Dockerfile? A. I recommend using a multi-stage Dockerfile, and doing the following On the stages where you build all your deps, and build your release make sure to install build-base and libgcc: # This step installs all the build tools we&#39;ll need RUN apk update &amp;&amp; \\ apk upgrade --no-cache &amp;&amp; \\ apk add --no-cache \\ git \\ curl \\ build-base \\ libgcc &amp;&amp; \\ mix local.rebar --force &amp;&amp; \\ mix local.hex --force Install the rust compiler and allow dynamic linking to the C library by setting the rust flag # install rustup RUN curl --proto &#39;=https&#39; --tlsv1.2 -sSf https://sh.rustup.rs | sh -s -- -y ENV RUSTUP_HOME=/root/.rustup \\ RUSTFLAGS=&quot;-C target-feature=-crt-static&quot; \\ CARGO_HOME=/root/.cargo \\ PATH=&quot;/root/.cargo/bin:$PATH&quot; On the stage where you actually run your elixir release install libgcc: ################################################################################ ## STEP 4 - FINAL FROM alpine:3.11 ENV MIX_ENV=prod RUN apk update &amp;&amp; \\ apk add --no-cache \\ bash \\ libgcc \\ openssl-dev COPY --from=release-builder /opt/built /app WORKDIR /app CMD [&quot;/app/my_app/bin/my_app&quot;, &quot;start&quot;]","ref":"readme.html#deploying","title":"README - Deploying","type":"extras"},{"doc":"FastRSS is released under the Apache License 2.0 - see the LICENSE file.","ref":"readme.html#license","title":"README - License","type":"extras"},{"doc":"CHANGELOG","ref":"changelog.html","title":"CHANGELOG","type":"extras"},{"doc":"Use erlang dirty scheduler Now requires OTP &gt;= 20 Added benchmark for normal vs dirty: normal vs dirty","ref":"changelog.html#v0-3-0","title":"CHANGELOG - v0.3.0","type":"extras"},{"doc":"User Map is returned with string keys instead of atom keys Now between 6.12x - 50.09x faster than next fastest tested option Internal Removed Jason dependency Returning elixir map directly instead of returning a stringified JSON and then using Jason to convert it to an elixir map","ref":"changelog.html#v0-2-0","title":"CHANGELOG - v0.2.0","type":"extras"},{"doc":"Convert RSS feed into map with atom keys Between 2.85x - 22.05x faster than next fastest tested option","ref":"changelog.html#v0-1-4","title":"CHANGELOG - v0.1.4","type":"extras"},{"doc":"Apache License Version 2.0, January 2004 http://www.apache.org/licenses/ TERMS AND CONDITIONS FOR USE, REPRODUCTION, AND DISTRIBUTION Definitions. &quot;License&quot; shall mean the terms and conditions for use, reproduction, and distribution as defined by Sections 1 through 9 of this document. &quot;Licensor&quot; shall mean the copyright owner or entity authorized by the copyright owner that is granting the License. &quot;Legal Entity&quot; shall mean the union of the acting entity and all other entities that control, are controlled by, or are under common control with that entity. For the purposes of this definition, &quot;control&quot; means (i) the power, direct or indirect, to cause the direction or management of such entity, whether by contract or otherwise, or (ii) ownership of fifty percent (50%) or more of the outstanding shares, or (iii) beneficial ownership of such entity. &quot;You&quot; (or &quot;Your&quot;) shall mean an individual or Legal Entity exercising permissions granted by this License. &quot;Source&quot; form shall mean the preferred form for making modifications, including but not limited to software source code, documentation source, and configuration files. &quot;Object&quot; form shall mean any form resulting from mechanical transformation or translation of a Source form, including but not limited to compiled object code, generated documentation, and conversions to other media types. &quot;Work&quot; shall mean the work of authorship, whether in Source or Object form, made available under the License, as indicated by a copyright notice that is included in or attached to the work (an example is provided in the Appendix below). &quot;Derivative Works&quot; shall mean any work, whether in Source or Object form, that is based on (or derived from) the Work and for which the editorial revisions, annotations, elaborations, or other modifications represent, as a whole, an original work of authorship. For the purposes of this License, Derivative Works shall not include works that remain separable from, or merely link (or bind by name) to the interfaces of, the Work and Derivative Works thereof. &quot;Contribution&quot; shall mean any work of authorship, including the original version of the Work and any modifications or additions to that Work or Derivative Works thereof, that is intentionally submitted to Licensor for inclusion in the Work by the copyright owner or by an individual or Legal Entity authorized to submit on behalf of the copyright owner. For the purposes of this definition, &quot;submitted&quot; means any form of electronic, verbal, or written communication sent to the Licensor or its representatives, including but not limited to communication on electronic mailing lists, source code control systems, and issue tracking systems that are managed by, or on behalf of, the Licensor for the purpose of discussing and improving the Work, but excluding communication that is conspicuously marked or otherwise designated in writing by the copyright owner as &quot;Not a Contribution.&quot; &quot;Contributor&quot; shall mean Licensor and any individual or Legal Entity on behalf of whom a Contribution has been received by Licensor and subsequently incorporated within the Work. Grant of Copyright License. Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable copyright license to reproduce, prepare Derivative Works of, publicly display, publicly perform, sublicense, and distribute the Work and such Derivative Works in Source or Object form. Grant of Patent License. Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable (except as stated in this section) patent license to make, have made, use, offer to sell, sell, import, and otherwise transfer the Work, where such license applies only to those patent claims licensable by such Contributor that are necessarily infringed by their Contribution(s) alone or by combination of their Contribution(s) with the Work to which such Contribution(s) was submitted. If You institute patent litigation against any entity (including a cross-claim or counterclaim in a lawsuit) alleging that the Work or a Contribution incorporated within the Work constitutes direct or contributory patent infringement, then any patent licenses granted to You under this License for that Work shall terminate as of the date such litigation is filed. Redistribution. You may reproduce and distribute copies of the Work or Derivative Works thereof in any medium, with or without modifications, and in Source or Object form, provided that You meet the following conditions: (a) You must give any other recipients of the Work or Derivative Works a copy of this License; and (b) You must cause any modified files to carry prominent notices stating that You changed the files; and (c) You must retain, in the Source form of any Derivative Works that You distribute, all copyright, patent, trademark, and attribution notices from the Source form of the Work, excluding those notices that do not pertain to any part of the Derivative Works; and (d) If the Work includes a &quot;NOTICE&quot; text file as part of its distribution, then any Derivative Works that You distribute must include a readable copy of the attribution notices contained within such NOTICE file, excluding those notices that do not pertain to any part of the Derivative Works, in at least one of the following places: within a NOTICE text file distributed as part of the Derivative Works; within the Source form or documentation, if provided along with the Derivative Works; or, within a display generated by the Derivative Works, if and wherever such third-party notices normally appear. The contents of the NOTICE file are for informational purposes only and do not modify the License. You may add Your own attribution notices within Derivative Works that You distribute, alongside or as an addendum to the NOTICE text from the Work, provided that such additional attribution notices cannot be construed as modifying the License. You may add Your own copyright statement to Your modifications and may provide additional or different license terms and conditions for use, reproduction, or distribution of Your modifications, or for any such Derivative Works as a whole, provided Your use, reproduction, and distribution of the Work otherwise complies with the conditions stated in this License. Submission of Contributions. Unless You explicitly state otherwise, any Contribution intentionally submitted for inclusion in the Work by You to the Licensor shall be under the terms and conditions of this License, without any additional terms or conditions. Notwithstanding the above, nothing herein shall supersede or modify the terms of any separate license agreement you may have executed with Licensor regarding such Contributions. Trademarks. This License does not grant permission to use the trade names, trademarks, service marks, or product names of the Licensor, except as required for reasonable and customary use in describing the origin of the Work and reproducing the content of the NOTICE file. Disclaimer of Warranty. Unless required by applicable law or agreed to in writing, Licensor provides the Work (and each Contributor provides its Contributions) on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied, including, without limitation, any warranties or conditions of TITLE, NON-INFRINGEMENT, MERCHANTABILITY, or FITNESS FOR A PARTICULAR PURPOSE. You are solely responsible for determining the appropriateness of using or redistributing the Work and assume any risks associated with Your exercise of permissions under this License. Limitation of Liability. In no event and under no legal theory, whether in tort (including negligence), contract, or otherwise, unless required by applicable law (such as deliberate and grossly negligent acts) or agreed to in writing, shall any Contributor be liable to You for damages, including any direct, indirect, special, incidental, or consequential damages of any character arising as a result of this License or out of the use or inability to use the Work (including but not limited to damages for loss of goodwill, work stoppage, computer failure or malfunction, or any and all other commercial damages or losses), even if such Contributor has been advised of the possibility of such damages. Accepting Warranty or Additional Liability. While redistributing the Work or Derivative Works thereof, You may choose to offer, and charge a fee for, acceptance of support, warranty, indemnity, or other liability obligations and/or rights consistent with this License. However, in accepting such obligations, You may act only on Your own behalf and on Your sole responsibility, not on behalf of any other Contributor, and only if You agree to indemnify, defend, and hold each Contributor harmless for any liability incurred by, or claims asserted against, such Contributor by reason of your accepting any such warranty or additional liability. END OF TERMS AND CONDITIONS","ref":"license.html","title":"LICENSE","type":"extras"}]